// RfidSockLib.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "RfidSockLib.h"
#include "WcqCycQueue.h"
#include <Winsock2.h>


#define RECVBUFLEN 2048


HANDLE  g_hMutexSwap;
bool   g_bRunning=false;


SOCKET g_sockSrv;
SOCKADDR_IN g_addrSrv;

WcqCycQueue<TAGDATA> g_queueTag;


DWORD __stdcall MainThreadProc(void * pParam);
DWORD __stdcall ClientThreadProc(void * pParam);
int ReadAddr(SOCKET sockClient);

RCVDATE g_pRecvDataFunc=NULL;
void * g_pUserData=NULL;

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}


RFIDSOCKLIB_API bool Start(int port)
{
	//*****ʼsocket̻****
	WORD wVersionRequested;
	WSADATA wsaData;
	int err;
	wVersionRequested = MAKEWORD( 1, 1 );
	err = WSAStartup( wVersionRequested, &wsaData );
	if ( err != 0 ) 
	{
	   return false;
	}
	if ( LOBYTE( wsaData.wVersion ) != 1 || 	HIBYTE( wsaData.wVersion ) != 1 ) 
	{
	   WSACleanup();
	   return false; 
	}
	
	//*********Tcpsocket*************
	g_sockSrv = socket( AF_INET , SOCK_STREAM , 0 );

	//ַ
	SOCKADDR_IN addrSrv ;
	addrSrv.sin_addr.S_un.S_addr = htonl(INADDR_ANY) ;
	addrSrv.sin_family = AF_INET ;
	addrSrv.sin_port = htons(port) ;

	//socketַһ
	int ret = bind( g_sockSrv ,(SOCKADDR*)&addrSrv , sizeof(SOCKADDR) ) ;
	if(SOCKET_ERROR==ret)
	{
		closesocket(g_sockSrv);
		return false;
	}

	//ʼͻ,Ϊ5
	ret = listen( g_sockSrv , 5 ) ;
	if(SOCKET_ERROR==ret)
	{
		closesocket(g_sockSrv);
		return false;
	}

	g_bRunning=true;

	g_hMutexSwap = CreateMutex(NULL,FALSE,NULL);
	CreateThread(NULL,0,MainThreadProc,NULL,0,NULL);

	g_queueTag.ClearQueue();
	return true;
}

RFIDSOCKLIB_API void Stop()
{
	g_bRunning =false;
}

RFIDSOCKLIB_API bool SetRecvProcAddr(RCVDATE RcvAddr,void* pUserData)
{
	g_pRecvDataFunc=RcvAddr;
	g_pUserData = pUserData;

	return true;
}



RFIDSOCKLIB_API int GetTagCount()
{
	int count =0;
	unsigned long dw = WaitForSingleObject(g_hMutexSwap, 100);
	if(dw == WAIT_OBJECT_0) 
	{			
		count = g_queueTag.GetLength();

		ReleaseMutex(g_hMutexSwap);
	}
	return count;
}

RFIDSOCKLIB_API int GetTagData(TAGDATA buf[],int count)
{
	int n=0;
	unsigned long dw = WaitForSingleObject(g_hMutexSwap, 100);
	if(dw == WAIT_OBJECT_0) 
	{			
		while( n<count && g_queueTag.GetLength()>0 )
		{
			TAGDATA tag;
			g_queueTag.Pop(tag);
			buf[n++] = tag;
		}
		ReleaseMutex(g_hMutexSwap);
	}

	return n;
}


DWORD __stdcall MainThreadProc(void * pParam)
{
	struct  timeval outtimeListern ;  // ʱṹ
	outtimeListern.tv_sec = 0;  
	outtimeListern.tv_usec =500;
	
	// selectģʹ
	// 1ʼһ׽ּfdSocketӼ׽־
	 fd_set fdSocket;  // п׽ּ
	 FD_ZERO(&fdSocket);
	 FD_SET(g_sockSrv, &fdSocket);

	//Ͻտͻ˷͵
	while ( g_bRunning )
	{
		Sleep(100);

	    // 2fdSocketϵһfdReadݸselect
	    // ¼ʱselectƳfdReadûδI/O׽־Ȼ󷵻ء
	    fd_set fdRead = fdSocket;
	    int nRet = ::select(0, &fdRead, NULL, NULL, &outtimeListern);
		if(nRet > 0)
		{
			// 3ͨԭfdSocketselectfdReadϱȽϣ
			// ȷЩ׽δI/OһЩI/O
		   for(int i=0; i<(int)fdSocket.fd_count; i++)
		   {
				if(FD_ISSET(fdSocket.fd_array[i], &fdRead))
				{
					 if(fdSocket.fd_array[i] == g_sockSrv)  // 1׽ֽյ
					 {
						  if(fdSocket.fd_count < FD_SETSIZE)
						  {
							   sockaddr_in addrRemote;
							   int nAddrLen = sizeof(addrRemote);
							   SOCKET sockClient = ::accept(g_sockSrv, (SOCKADDR*)&addrRemote, &nAddrLen);
							   //FD_SET(sNew, &fdSocket);
							   //printf("յӣ%s\n", ::inet_ntoa(addrRemote.sin_addr));
							   //**********************************
							   CreateThread(NULL,0,ClientThreadProc,&sockClient,0,NULL);
							   //*************************************
						  }
						  else
						  {
							   //printf(" Too much connections! \n");
							   continue;
						  }
					 }
				}
		   }
		}
	}

	closesocket(g_sockSrv);

	return 0;
}

DWORD __stdcall ClientThreadProc(void * pParam)
{
	SOCKET sockClient = *((SOCKET*)(pParam));

	int addr = ReadAddr(sockClient);
	if(addr == 0)
	{
		closesocket(sockClient);
		return 0;
	}

	char recvBuf[RECVBUFLEN] ;
	int recvLen=0;

	//
    char sendBuf[5];
    sendBuf[0]=addr;
    sendBuf[1]=0x04; 
    sendBuf[2]=0x01;
    sendBuf[3]=0x03;

	//ճʱ
	struct   timeval outtime ;  // ʱṹ
	FD_SET fdr = {1, sockClient}; 
	outtime.tv_sec = 0;  
	outtime.tv_usec =100;
	int nSelectRet;

	while(g_bRunning)
	{
	   send(sockClient , sendBuf , 4, 0 ) ;
	   recvLen=0;
	  
	   Sleep(100);

	   for(int n=0;g_bRunning && n<10;n++)
	   {
			nSelectRet=::select(0, &fdr, NULL, NULL, &outtime); //ɶ״̬ 
			if(SOCKET_ERROR==nSelectRet) 
			{
				 closesocket(sockClient);
				 return 0;
			}
			if(nSelectRet==0) //ʱ޿ɶ 
			{
				continue;
			}
			else 
			{
				//
				int len = recv(sockClient , &recvBuf[recvLen] , 1024-recvLen , 0 ) ;
				if(len == -1)
				{
					closesocket(sockClient);
					return -1;
				}
				recvLen+=len;

				if( (recvLen>5) && ((unsigned char)recvBuf[0] == 0xff)&&((unsigned char)recvBuf[1] == 0xff) &&((unsigned char)recvBuf[recvLen-1] == 0xee)&&((unsigned char)recvBuf[recvLen-2] == 0xee) )
				{
					for(int index=4; g_bRunning && index<recvLen-6;index+=5)
					{
						bool bVoltLow = ((recvBuf[index] & 0x80)==0x80); //Ƿѹ־

						unsigned int tagID = (unsigned int)(recvBuf[index+1]);
						tagID <<=8;
						tagID |= (unsigned char)recvBuf[index+2];
						tagID <<=8;
						tagID |= (unsigned char)recvBuf[index+3];
						tagID <<=8;
						tagID |= (unsigned char)recvBuf[index+4];

						TAGDATA tagData;
						SYSTEMTIME st;
						GetLocalTime(&st);

						tagData.addr =addr;
						tagData.tagID = tagID;
						tagData.bVoltLow= bVoltLow;
					
						tagData.year = st.wYear;
						tagData.month = st.wMonth;
						tagData.day = st.wDay;
						tagData.hour = st.wHour;
						tagData.minute = st.wMinute;
						tagData.second =st.wSecond;
		
						unsigned long dw = WaitForSingleObject(g_hMutexSwap, 100);
						if(dw == WAIT_OBJECT_0) 
						{			
							g_queueTag.Push(tagData);

							ReleaseMutex(g_hMutexSwap);
						}	

//typedef int (CALLBACK* RCVDATE)(char* cCardId,char* cIp,int nVolt,void* pUserData);

						(*g_pRecvDataFunc)(&tagID,"192.168.1.123",0,g_pUserData);
					}
					break;
				}
			}
	   }
	}

	closesocket(sockClient);
	return 0;
}



int ReadAddr(SOCKET sockClient)
{
		//
    char sendBuf[5];
    sendBuf[0]=(unsigned char)0xFF;
    sendBuf[1]=(unsigned char)0xFF; 
    sendBuf[2]=(unsigned char)0x08;
    sendBuf[3]=(unsigned char)0xee;
	sendBuf[4]=(unsigned char)0xee;
 
	send(sockClient , sendBuf , 5, 0 ) ;

	 //ճʱ
	struct   timeval outtime ;  // ʱṹ
	FD_SET fdr = {1, sockClient}; 
	outtime.tv_sec = 1;  
	outtime.tv_usec =0;
	int nSelectRet;

	char recvBuf[10] ;

	nSelectRet=::select(0, &fdr, NULL, NULL, &outtime); //ɶ״̬ 
	if(nSelectRet==SOCKET_ERROR) 
	{
		 return 0;
	}
	if(nSelectRet==0) //ʱ޿ɶ 
	{
		return 0;
	}
	else
	{
		int retLen = recv(sockClient , recvBuf , 5 , 0 ) ;
		if(retLen == -1)
		{
			return 0;
		}

		if( (retLen>=5) && ((unsigned char)recvBuf[0] == 0xff)&&((unsigned char)recvBuf[1] == 0xff) &&((unsigned char)recvBuf[3] == 0xee)&&((unsigned char)recvBuf[4] == 0xee) )
		{
			return (int)(recvBuf[2]);
		}
	}

	return 0;
}

